package com.css.simulation.resource.monitor.scheduler;

import api.common.pojo.dto.Gpu;
import api.common.pojo.dto.Host;
import api.common.pojo.po.home.SystemServerPO;
import api.common.util.SshUtil;
import api.common.util.StringUtil;
import lombok.Data;
import org.apache.sshd.client.session.ClientSession;
import org.dom4j.DocumentException;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.util.List;

@Component
@ConfigurationProperties(prefix = "ssh")
@Data
public class MyScheduler {

    List<Host> hostList;

    @Scheduled(fixedDelay = 60 * 60 * 1000)
    public void server() {


        hostList.forEach(host ->{

            String ip = host.getHostname();
            Integer port = host.getPort();
            String username = host.getUsername();
            String password = host.getPassword();
            String type = host.getType();

            try {
                ClientSession session = SshUtil.getSession(ip, username, password);
//                if ("gpu".equals(type)){
//                    List<Gpu> gpuList = SshUtil.gpuInfo(session);
//                    gpuList.forEach(gpu -> {
//                        gpu.get
//                    });
//                }

                SystemServerPO systemServerPO = SystemServerPO.builder()
                        .id(StringUtil.getRandomUUID())
                        .serverId(SshUtil.hostname(session))
                        .serverAddress(ip)
                        .serverType(type)
                        .cpuUsage((int) SshUtil.cpuUsage(session))
                        .memoryUsage((int) SshUtil.memoryUsage(session))
                        .memoryAvailable(SshUtil.memoryAvailable(session))
                        .diskUsage((int) SshUtil.diskUsage(session))
                        .diskAvailable(SshUtil.diskAvailable(session))
//                        .taskNumber()
//                        .weight()
//                        .gpuUsage("gpu".equals(type)?SshUtil.gpu(session).stream().mapto :0)
                        .build();
            } catch (Exception e) {
                e.printStackTrace();
            }
        });


    }


}
